unit parallel_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  LResources, ExtCtrls
  {$IFDEF WIN32}
  , Windows
  {$ENDIF}

  {$IFDEF Unix}
  , clib, ports //für die Rechte und Portoptionen
  {$ENDIF}
  ;

type

  { TformParallel }

  TInp32 = function(Address: SmallInt): SmallInt; StdCall;
  TOut32 = procedure(Address: SmallInt; Data: SmallInt); StdCall;

  TformParallel = class(TForm)
    buttonReceive: TButton;
    buttonSend: TButton;
    editReceived: TEdit;
    editSend: TEdit;
    editPort: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure buttonReceiveClick(Sender: TObject);
    procedure buttonSendClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  formParallel: TformParallel;

  {$IFDEF Unix}
  function ioperm(form:Cardinal; num:Cardinal; turn_on:Integer): Integer;
           CDecl; external clib;
  {$ENDIF}

implementation

{$R *.lfm}

{ TformParallel }

procedure TformParallel.buttonSendClick(Sender: TObject);
var
  PortAddress: Integer;
  Data: Byte;

begin
  PortAddress := StrToInt(editPort.text);
  Data := StrToInt(editSend.Text);

  {$IFDEF Win32}
  Out32(PortAddress,Data);
  {$ENDIF}

  {$IFDEF Unix}
  ioperm(PortAdress, 8, 1);
  port[Address] := Data;
  {$ENDIF}
end;

procedure TformParallel.buttonReceiveClick(Sender: TObject);
var
  PortAddress: Integer;

begin
  PortAddress := StrToInt(editPort.text);

  {$IFDEF Win32}
  editReceived.Text := IntToHex(Inp32(PortAddress),2);
  {$ENDIF}

  {$IFDEF Unix}
  editReceived.Text := IntToHex(Port[PortAdress],2);
  {$ENDIF}
end;

procedure TformParallel.FormDestroy(Sender: TObject);
begin
  {$IFDEF Win32}
  FreeLibrary(Inpout32);
  {$ENDIF}

end;

initialization
 {$→ parallel_form.lrs}

end.

